      function numcor()
c-----------------------------------------------------------------------
c     This function returns the number of cores of the system.
c     Coded by H. Akai, 13 Feb. 2015, Tokyo
c     Revised by H. Akai, Tokyo, Nov. 1, 2020
c-----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      character*80 a,tmpfil*6,command
      logical exist
      data inicor/4/
      numcor=inicor
      do 10 i=0,999
      write(tmpfil,'(a,i3.3)')'tmp',i
      inquire(file=tmpfil,exist=exist)
      if(.not. exist) exit
   10 continue
      if(exist) then
      write(*,'(a)')' create temporary file failed:'
      write(*,'(a,i2,a)')' number of cores=',inicor,' is assumed.'
      return
      endif
c
      open(13,file=tmpfil)
      command='uname -a>'//tmpfil
      istat=system(command)
      if(istat .ne. 0) then
      write(*,'(a)')' operating system not available:'
      write(*,'(a,i2,a)')' number of cores=',inicor,' is assumed.'
c     --- for some systems, it is necessary to close the file here
c         to ensure that data is actually written down on the device.
      close(13)
      command='rm '//tmpfil
      istat=system(command)
      return
      endif
c
      read(13,'(a)')a
      if(a(1:5) .eq. 'Linux') then
c     --- assume the system is LINUX
      command='nproc --all>'//tmpfil
      istat=system(command)
      close(13)
      open(13,file=tmpfil)
      else if(a(1:6) .eq. 'Darwin') then
c
c     --- assume the system is DARWIN (MAC)
      command='sysctl -n machdep.cpu.thread_count>'//tmpfil
      else
      write(*,'(a)')' operating system not known:'
      write(*,'(a,i2,a)')' number of cores=',inicor,' is assumed.'
      close(13)
      command='rm '//tmpfil
      istat=system(command)
      return
      endif
c
c     istat=system(command)
      if(istat .ne. 0) then
      write(*,'(a)')' cpu information not available:'
      write(*,'(a,i2,a)')' number of cores=',inicor,' is assumed.'
      close(13)
      command='rm '//tmpfil
      istat=system(command)
      return
      endif
c
      read(13,*,end=20,err=20)numcor
      close(13)
      command='rm '//tmpfil
      istat=system(command)
      return
c
   20 write(*,'(a)')' read fails cpu information not available:'
      write(*,'(a,i2,a)')' number of cores=',inicor,' is assumed.'
      close(13)
      command='rm '//tmpfil
      istat=system(command)
      return
      end
